<?php

namespace App\Http\Requests;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Validation\ValidationException;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed email
 * @property mixed message
 * @property mixed visitor_email
 * @property mixed reply
 * @property mixed name
 * @property mixed subject
 */
class CareerRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (Auth::guest()) {
            return true;
        }
        if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        if(Auth::user()->hasModule( 'careers' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [];
        if (Auth::user() && Auth::user()->role){
            $admin_rules = [
                'visitor_email' => 'required|email',
                'reply' => 'required|min:10',
            ];

            $rules = array_merge($rules, $admin_rules);

        } else{

            $visitor_rules = [
                'name' => 'required|min:3',
                'email' => 'required|email',
                'phone' => 'required|digits_between:9,15',
                'type' => 'required|in:individuals,companies',
                'job_file' => 'required|mimes:pdf',
                'message' => 'required|min:3|max:255',
            ];

            $rules = array_merge($rules, $visitor_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('careers');
        $local = getCurrentLocale();

        $attributes = [
            'name' => __('careers.name') ?? $field[$local]['name'],
            'email' => __('careers.email') ?? $field[$local]['email'],
            'phone' => __('careers.phone') ?? $field[$local]['phone'],
            'type' => __('careers.type') ?? $field[$local]['type'],
            'job_file' => __('careers.job_file') ?? $field[$local]['job_file'],
            'message' => __('careers.message') ?? $field[$local]['message'],
            'visitor_email' => __('careers.visitor_email') ?? $field[$local]['visitor_email'],
            'reply' => __('careers.reply') ?? $field[$local]['reply'],
        ];

        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::ajax()){
            if ($validator->fails()){
                $errors = $validator->errors()->first();
                throw new HttpResponseException(response()->json(['errors' => $errors]));
            }

        } else {
            parent::failedValidation($validator);
        }
    }
}
